function setup()
{
	if (window.widget && widget.preferenceForKey("currentStyle")) {
		setActiveStyleSheet() = widget.preferenceForKey("currentStyle");
	}
}

function getpref() {
	var currentStyle;

	if (window.widget) getActiveStyleSheet() = widget.preferenceForKey("currentStyle");
	if ( ! getActiveStyleSheet() ) getActiveStyleSheet() = "MEDteal"; // Default value if preference is not available

	return currentStyle;
}

function onshow() {
    if (timer == null) {
        updateTime();
        timer = setInterval("updateTime();", 1000);
    }
	startclock(); 
}

//When Dashboard is hidden, onhide halts the timer:

function onhide() {
    if (timer != null) {
        clearInterval(timer);
        timer = null;
    }
}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
		
// clean up the front side - hide the circle behind the info button
	document.getElementById('fliprollie').style.display = 'none';  
}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	//widget.setPreferenceForKey(document.getElementById("worldPopup").value,"worldString")
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');				// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}


/*********************************/
// CLOCK FUNCTIONS
/*********************************/
function startclock()
{
var thetime=new Date();

var nhours=thetime.getHours();
var nmins=thetime.getMinutes();
var nsecn=thetime.getSeconds();
var nday=thetime.getDay();
var nmonth=thetime.getMonth();
var ntoday=thetime.getDate();
var nyear=thetime.getYear();

//Change background image depending on the time
 if (nhours>=12)
	document.getElementById('ampm').innerText = "PM";
else
	document.getElementById ('ampm').innerText = "AM";

if (nhours>=13)
    nhours-=12;

if (nhours==0)
   nhours=12;

if (nsecn<10)
 nsecn="0"+nsecn;

if (nmins<10)
 nmins="0"+nmins;

if (nhours<10)
 nhours="0"+nhours;

if (nday==0)
  nday="Sunday";
if (nday==1)
  nday="Monday";
if (nday==2)
  nday="Tuesday";
if (nday==3)
  nday="Wednesday";
if (nday==4)
  nday="Thursday";
if (nday==5)
  nday="Friday";
if (nday==6)
  nday="Saturday";

//nmonth+=1;
if (nmonth==0)
  nmonth="Jan.";
if (nmonth==1)
  nmonth="Feb.";
if (nmonth==2)
  nmonth="Mar.";
if (nmonth==3)
  nmonth="Apr.";
if (nmonth==4)
  nmonth="May";
if (nmonth==5)
  nmonth="June";
if (nmonth==6)
  nmonth="July";
if (nmonth==7)
  nmonth="Aug.";
if (nmonth==8)
  nmonth="Sept.";
if (nmonth==9)
  nmonth="Oct.";
if (nmonth==10)
  nmonth="Nov.";
if (nmonth==11)
  nmonth="Dec.";

//fixes y2k bug
if (nyear<=99)
  nyear= "19"+nyear;
if ((nyear>99) && (nyear<2000))
 nyear+=1900;
 
//return results to specific DIV tags
			document.getElementById('clock').innerText = nhours+":"+nmins+":"+nsecn;
			document.getElementById('date').innerText = nday+", "+nmonth+" "+ntoday;
			
setTimeout('startclock()',1000);
} 